//+------------------------------------------------------------------+
//|                                                    Amplituda.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  Aqua

extern int    Bar          = 24;       // 
extern bool   File         = false;    //   
//---- indicator buffers
double      ExtBuffer0[];
bool        Save=true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   if(Bar<=0)Bar=1;
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
//---- 4 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer0);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Amplituda ( "+Bar+" )");
   SetIndexLabel(0,"Amplituda "+Bar);
//---- initialization done
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    limit,Error;
   double Max,Min;
   
//----
   if(Save && File)
   {
      string FileName="Amplituda "+Symbol()+Period()+" "+Bar+".csv";

      int handle=FileOpen(FileName,FILE_CSV|FILE_READ);
      if(handle<1)
      {
         handle=FileOpen(FileName,FILE_CSV|FILE_WRITE,';');
      }
      else
      {
         FileClose(handle);
         FileDelete(FileName);
         handle=FileOpen(FileName,FILE_CSV|FILE_WRITE,';');
      }
   }
   

//---- 
   int counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars-Bar;
   if(limit<1)limit=1;
//---- 
   if(ExtBuffer0[0]!=0)ExtBuffer0[0]=0;
   for(int i=0; i<limit; i++)
   {
      Max=iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Bar,i));
      Min=iLow(NULL,0,iLowest(NULL,0,MODE_LOW,Bar,i));

      ExtBuffer0[i]=(Max-Min)/Point;

      if(Save && File)FileWrite(handle,ExtBuffer0[i]);
   }
   if(Save && File)
   {
      FileClose(handle);
      Save=false;
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+